SettableBeanProperty.ManagedReferenceProperty (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser

## Class SettableBeanProperty.ManagedReferenceProperty

- java.lang.Object
- - org.codehaus.jackson.map.deser.SettableBeanProperty
  - - org.codehaus.jackson.map.deser.SettableBeanProperty.ManagedReferenceProperty

- All Implemented Interfaces:
    BeanProperty, Named
  Enclosing class:
    SettableBeanProperty

      public static final class SettableBeanProperty.ManagedReferenceProperty
      extends SettableBeanProperty

  Wrapper property that is used to handle managed (forward) properties (see [JACKSON-235] for more information). Basically just need to delegate first to actual forward property, and
  Author:
    tatu

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `SettableBeanProperty.FieldProperty, SettableBeanProperty.InnerClassProperty, SettableBeanProperty.ManagedReferenceProperty, SettableBeanProperty.MethodProperty, SettableBeanProperty.NullProvider, SettableBeanProperty.SetterlessProperty`

    - ### Nested classes/interfaces inherited from interface org.codehaus.jackson.map.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SettableBeanProperty` | `_backProperty`
    `protected boolean` | `_isContainer` Flag that indicates whether property to handle is a container type (array, Collection, Map) or not.
    `protected SettableBeanProperty` | `_managedProperty`
    `protected String` | `_referenceName`

    - ### Fields inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _nullProvider, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SettableBeanProperty.ManagedReferenceProperty(SettableBeanProperty.ManagedReferenceProperty src, JsonDeserializer<Object> deser)`
    `` | `SettableBeanProperty.ManagedReferenceProperty(String refName, SettableBeanProperty forward, SettableBeanProperty backward, Annotations contextAnnotations, boolean isContainer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `<A extends Annotation> A` | `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `set(Object instance, Object value)`
    `SettableBeanProperty.ManagedReferenceProperty` | `withValueDeserializer(JsonDeserializer<Object> deser)`

    - ### Methods inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, assignIndex, deserialize, getContextAnnotation, getDeclaringClass, getInjectableValueId, getManagedReferenceName, getName, getPropertyIndex, getPropertyName, getProperytIndex, getType, getValueDeserializer, getValueTypeDeserializer, hasValueDeserializer, hasValueTypeDeserializer, setManagedReferenceName, setValueDeserializer, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _referenceName

          protected final String _referenceName

    - #### _isContainer

          protected final boolean _isContainer

      Flag that indicates whether property to handle is a container type (array, Collection, Map) or not.

    - #### _managedProperty

          protected final SettableBeanProperty _managedProperty

    - #### _backProperty

          protected final SettableBeanProperty _backProperty

  - ### Constructor Detail

    - #### SettableBeanProperty.ManagedReferenceProperty

          public SettableBeanProperty.ManagedReferenceProperty(String refName,
                                                       SettableBeanProperty forward,
                                                       SettableBeanProperty backward,
                                                       Annotations contextAnnotations,
                                                       boolean isContainer)

    - #### SettableBeanProperty.ManagedReferenceProperty

          protected SettableBeanProperty.ManagedReferenceProperty(SettableBeanProperty.ManagedReferenceProperty src,
                                                       JsonDeserializer<Object> deser)

  - ### Method Detail

    - #### withValueDeserializer

          public SettableBeanProperty.ManagedReferenceProperty withValueDeserializer(JsonDeserializer<Object> deser)

      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`

    - #### getAnnotation

          public <A extends Annotation> A getAnnotation(Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(JsonParser jp,
                               DeserializationContext ctxt,
                               Object instance)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### set

          public final void set(Object instance,
                 Object value)
                         throws IOException

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `IOException`